Index: trunk/ArchTOIPipe/Kernel/toimanager.cc
===================================================================
--- trunk/ArchTOIPipe/Kernel/toimanager.cc	(revision 1671)
+++ trunk/ArchTOIPipe/Kernel/toimanager.cc	(revision 1684)
@@ -1,11 +1,14 @@
 #include "toimanager.h"
-#include <unistd.h>
 #include <limits.h>
 #include <pthread.h>
 #include <iostream.h>
 
+#ifndef MAXINT
+#define MAXINT 2147483647
+#endif
+
 TOIManager::TOIManager() {
   reqBegin = 0;
-  reqEnd = LONG_MAX;
+  reqEnd = MAXINT;
 }
 
@@ -17,14 +20,14 @@
 }
 
-void TOIManager::setRequestedSample(long begin, long end) {
+void TOIManager::setRequestedSample(int begin, int end) {
   reqBegin = begin;
   reqEnd   = end;
 }
 
-long TOIManager::getRequestedBegin() {
+int TOIManager::getRequestedBegin() {
   return reqBegin;
 }
 
-long TOIManager::getRequestedEnd() {
+int TOIManager::getRequestedEnd() {
   return reqEnd;
 }
@@ -44,73 +47,2 @@
   }
 }
-
-
-// -----------------------------------------------------------------
-//    Classe pour affichage de l'avancement des TOIProcessors 
-//                         Reza 08/2001 
-// -----------------------------------------------------------------
-
-RzProcSampleCounter::RzProcSampleCounter()
-{
-  _msg = "SampleCounter/Info";
-  _rate = 50;
-}
-
-RzProcSampleCounter::~RzProcSampleCounter()
-{
-}
-
-long RzProcSampleCounter::PrintStats()
-{
-  int istart = 0;
-  int iend = 0;
-  long dns_print = 1000;
-  int dns_print_fac = _rate;
-  int nbmax_dns_print = 2;
-
-  TOIManager* mgr = TOIManager::getManager();
-  
-  istart = mgr->getRequestedBegin();
-  iend = mgr->getRequestedEnd();
-  
-  dns_print = (iend-istart)/dns_print_fac;
-  if (dns_print < 1000) dns_print = ((iend-istart) < 1000) ? (iend-istart) : 1000;
-  if (dns_print < 1) dns_print = 1;
-  nbmax_dns_print = (iend-istart)/dns_print;
-
-  cout << "RzProcSampleCounter::PrintStats() InfoMessage=" << _msg 
-       << "\n ... " << _msg << " istart=" 
-       << istart << " iend= " << iend << " dns_print= " << dns_print
-       << " nbmax_dns_print= " << nbmax_dns_print << endl;
-  // ------------------- Impression continu de stat ------------------------ 
-  long nb_dns_print = 0;
-  int nb_sleep = 0;
-  long last_sample_count = 0;
-  long processed_samples = 0;
-  long total_sample_count = dns_print*nbmax_dns_print;
-  bool alldone = false;
-  while (!alldone) {
-    processed_samples = ProcessedSampleCount();
-    if ( (processed_samples-last_sample_count > dns_print) || 
-	 (processed_samples > total_sample_count-10) ) {
-      last_sample_count = processed_samples;
-      if (nb_dns_print == 0) cout << "\n";
-      nb_dns_print++;
-      cout << ">>> " << _msg << ": ProcessedSampleCount()= " << last_sample_count 
-	   << " Frac done = " << processed_samples*100/total_sample_count << " %" << endl;
-      if (last_sample_count > total_sample_count-10)  alldone = true;
-      nb_sleep = 0;
-    }
-    else if ((nb_sleep+1)%5 == 0) 
-      cout << "> " << _msg << ": ProcSamples()= " <<  processed_samples 
-	   << " Done = " << " %" << processed_samples*100/total_sample_count
-	   << " NbSleep(1) = " << nb_sleep << endl;
-    
-    sleep(1);  nb_sleep++;
-  }
-  
-  // -----------------------------------------------------------------------
-  
-  return last_sample_count;
-
-}
Index: trunk/ArchTOIPipe/Kernel/toimanager.h
===================================================================
--- trunk/ArchTOIPipe/Kernel/toimanager.h	(revision 1671)
+++ trunk/ArchTOIPipe/Kernel/toimanager.h	(revision 1684)
@@ -4,5 +4,4 @@
 #define TOIMANAGER_H
 
-#include <string>
 #include <vector>
 
@@ -12,7 +11,7 @@
 public:
   static TOIManager* getManager();
-  void setRequestedSample(long begin, long end);
-  long getRequestedBegin();
-  long getRequestedEnd();
+  void setRequestedSample(int begin, int end);
+  int getRequestedBegin();
+  int getRequestedEnd();
   void addThread(pthread_t*);
   void joinAll();
@@ -27,32 +26,3 @@
 };
 
-
-// -----------------------------------------------------------------
-//    Classe pour affichage de l'avancement des TOIProcessors 
-//                         Reza 08/2001 
-// -----------------------------------------------------------------
-
-class RzProcSampleCounter {
-public:
-                RzProcSampleCounter();
-  virtual       ~RzProcSampleCounter();
-  virtual long	ProcessedSampleCount() = 0;
-  virtual long  PrintStats();
-  inline int &  PrintRate(int pr) { return _rate; } 
-  inline string& InfoMessage() { return _msg; } 
-protected:
-  int _rate;
-  string _msg;
-};
-
-template <class T>
-class ProcSampleCounter : public RzProcSampleCounter {
-public:
-                ProcSampleCounter(const T & t) { _t = &t; } 
-  virtual long	ProcessedSampleCount()
-                      { return _t->ProcessedSampleCount(); }
-protected:
-  const T * _t;
-};
-
 #endif