Index: /trunk/ArchTOIPipe/Kernel/toimanager.cc
===================================================================
--- /trunk/ArchTOIPipe/Kernel/toimanager.cc	(revision 1701)
+++ /trunk/ArchTOIPipe/Kernel/toimanager.cc	(revision 1702)
@@ -1,11 +1,14 @@
 #include "toimanager.h"
-#include <unistd.h>
 #include <limits.h>
 #include <pthread.h>
 #include <iostream.h>
 
+#ifndef MAXINT
+#define MAXINT 2147483647
+#endif
+
 TOIManager::TOIManager() {
   reqBegin = 0;
-  reqEnd = LONG_MAX;
+  reqEnd = MAXINT;
 }
 
@@ -17,14 +20,14 @@
 }
 
-void TOIManager::setRequestedSample(long begin, long end) {
+void TOIManager::setRequestedSample(int begin, int end) {
   reqBegin = begin;
   reqEnd   = end;
 }
 
-long TOIManager::getRequestedBegin() {
+int TOIManager::getRequestedBegin() {
   return reqBegin;
 }
 
-long TOIManager::getRequestedEnd() {
+int TOIManager::getRequestedEnd() {
   return reqEnd;
 }
@@ -93,10 +96,10 @@
     processed_samples = ProcessedSampleCount();
     if ( (processed_samples-last_sample_count > dns_print) || 
-	 (processed_samples > total_sample_count-10) ) {
+         (processed_samples > total_sample_count-10) ) {
       last_sample_count = processed_samples;
       if (nb_dns_print == 0) cout << "\n";
       nb_dns_print++;
       cout << ">>> " << _msg << ": ProcessedSampleCount()= " << last_sample_count 
-	   << " Frac done = " << processed_samples*100/total_sample_count << " %" << endl;
+           << " Frac done = " << processed_samples*100/total_sample_count << " %" << endl;
       if (last_sample_count > total_sample_count-10)  alldone = true;
       nb_sleep = 0;
@@ -104,6 +107,6 @@
     else if ((nb_sleep+1)%5 == 0) 
       cout << "> " << _msg << ": ProcSamples()= " <<  processed_samples 
-	   << " Done = " << " %" << processed_samples*100/total_sample_count
-	   << " NbSleep(1) = " << nb_sleep << endl;
+           << " Done = " << " %" << processed_samples*100/total_sample_count
+           << " NbSleep(1) = " << nb_sleep << endl;
     
     sleep(1);  nb_sleep++;
Index: /trunk/ArchTOIPipe/Kernel/toimanager.h
===================================================================
--- /trunk/ArchTOIPipe/Kernel/toimanager.h	(revision 1701)
+++ /trunk/ArchTOIPipe/Kernel/toimanager.h	(revision 1702)
@@ -12,7 +12,7 @@
 public:
   static TOIManager* getManager();
-  void setRequestedSample(long begin, long end);
-  long getRequestedBegin();
-  long getRequestedEnd();
+  void setRequestedSample(int begin, int end);
+  int getRequestedBegin();
+  int getRequestedEnd();
   void addThread(pthread_t*);
   void joinAll();
@@ -27,5 +27,4 @@
 };
 
-
 // -----------------------------------------------------------------
 //    Classe pour affichage de l'avancement des TOIProcessors 
@@ -35,7 +34,7 @@
 class RzProcSampleCounter {
 public:
-                RzProcSampleCounter();
+  RzProcSampleCounter();
   virtual       ~RzProcSampleCounter();
-  virtual long	ProcessedSampleCount() = 0;
+  virtual long  ProcessedSampleCount() = 0;
   virtual long  PrintStats();
   inline int &  PrintRate(int pr) { return _rate; } 
@@ -49,7 +48,7 @@
 class ProcSampleCounter : public RzProcSampleCounter {
 public:
-                ProcSampleCounter(const T & t) { _t = &t; } 
-  virtual long	ProcessedSampleCount()
-                      { return _t->ProcessedSampleCount(); }
+  ProcSampleCounter(const T & t) { _t = &t; } 
+  virtual long  ProcessedSampleCount()
+  { return _t->ProcessedSampleCount(); }
 protected:
   const T * _t;
@@ -57,2 +56,3 @@
 
 #endif
+
Index: /trunk/ArchTOIPipe/Makefile.in
===================================================================
--- /trunk/ArchTOIPipe/Makefile.in	(revision 1701)
+++ /trunk/ArchTOIPipe/Makefile.in	(revision 1702)
@@ -71,4 +71,5 @@
 	  if [ -d $$d ]; then \
             cd $$d; $(MAKE) clean; \
+	    cd ..; \
           fi  \
         done
Index: /trunk/ArchTOIPipe/ProcWSophya/Makefile.in
===================================================================
--- /trunk/ArchTOIPipe/ProcWSophya/Makefile.in	(revision 1701)
+++ /trunk/ArchTOIPipe/ProcWSophya/Makefile.in	(revision 1702)
@@ -80,5 +80,5 @@
 libatsop.a: $(FILES)
 	$(AR) -cr libatsop.a $(FILES) 
-	ranlib libatkern.a
+	ranlib libatsop.a
 	ln -f libatsop.a ../libatsop.a
 