Index: trunk/ArchTOIPipe/Kernel/Makefile.in
===================================================================
--- trunk/ArchTOIPipe/Kernel/Makefile.in	(revision 1705)
+++ trunk/ArchTOIPipe/Kernel/Makefile.in	(revision 1706)
@@ -6,4 +6,5 @@
 bindir = @bindir@
 CXX=@CXX@
+AR=@AR@
 CXXFLAGS=-O -g
 CFLAGS=-O -g
Index: trunk/ArchTOIPipe/Makefile.in
===================================================================
--- trunk/ArchTOIPipe/Makefile.in	(revision 1705)
+++ trunk/ArchTOIPipe/Makefile.in	(revision 1706)
@@ -72,9 +72,5 @@
 	  if [ -d $$d ]; then \
             cd $$d; $(MAKE) clean; \
-<<<<<<< Makefile.in
-            cd ..; \
-=======
 	    cd ..; \
->>>>>>> 1.5
           fi  \
         done
Index: trunk/ArchTOIPipe/ProcWSophya/Makefile.in
===================================================================
--- trunk/ArchTOIPipe/ProcWSophya/Makefile.in	(revision 1705)
+++ trunk/ArchTOIPipe/ProcWSophya/Makefile.in	(revision 1706)
@@ -6,4 +6,5 @@
 bindir = @bindir@
 CXX=@CXX@
+AR=@AR@
 CXXFLAGS=-O -g
 CFLAGS=-O -g
Index: trunk/ArchTOIPipe/Processors/Makefile.in
===================================================================
--- trunk/ArchTOIPipe/Processors/Makefile.in	(revision 1705)
+++ trunk/ArchTOIPipe/Processors/Makefile.in	(revision 1706)
@@ -6,4 +6,5 @@
 bindir = @bindir@
 CXX=@CXX@
+AR=@AR@
 CXXFLAGS=-O -g
 CFLAGS=-O -g
Index: trunk/ArchTOIPipe/TestPipes/Makefile.in
===================================================================
--- trunk/ArchTOIPipe/TestPipes/Makefile.in	(revision 1705)
+++ trunk/ArchTOIPipe/TestPipes/Makefile.in	(revision 1706)
@@ -6,4 +6,5 @@
 bindir = @bindir@
 CXX=@CXX@
+AR=@AR@
 CXXFLAGS=-O -g
 CFLAGS=-O -g
Index: trunk/ArchTOIPipe/configure
===================================================================
--- trunk/ArchTOIPipe/configure	(revision 1705)
+++ trunk/ArchTOIPipe/configure	(revision 1706)
@@ -910,4 +910,40 @@
 fi
 
+# Extract the first word of "ar", so it can be a program name with args.
+set dummy ar; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:916: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_AR'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$AR" in
+  /*)
+  ac_cv_path_AR="$AR" # Let the user override the test with a path.
+  ;;
+  ?:/*)			 
+  ac_cv_path_AR="$AR" # Let the user override the test with a dos path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS=":"
+  ac_dummy="/usr/bin:$PATH"
+  for ac_dir in $ac_dummy; do 
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_AR="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_AR" && ac_cv_path_AR="/usr/bin/ar"
+  ;;
+esac
+fi
+AR="$ac_cv_path_AR"
+if test -n "$AR"; then
+  echo "$ac_t""$AR" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+ 
 
 if test $GCC = "yes"; then
@@ -919,5 +955,5 @@
 
 echo $ac_n "checking size of short""... $ac_c" 1>&6
-echo "configure:922: checking size of short" >&5
+echo "configure:958: checking size of short" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_short'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -927,5 +963,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 930 "configure"
+#line 966 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -938,5 +974,5 @@
 }
 EOF
-if { (eval echo configure:941: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:977: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_short=`cat conftestval`
@@ -958,5 +994,5 @@
 
 echo $ac_n "checking size of int""... $ac_c" 1>&6
-echo "configure:961: checking size of int" >&5
+echo "configure:997: checking size of int" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_int'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -966,5 +1002,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 969 "configure"
+#line 1005 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -977,5 +1013,5 @@
 }
 EOF
-if { (eval echo configure:980: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1016: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_int=`cat conftestval`
@@ -997,5 +1033,5 @@
 
 echo $ac_n "checking size of long""... $ac_c" 1>&6
-echo "configure:1000: checking size of long" >&5
+echo "configure:1036: checking size of long" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_long'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1005,5 +1041,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1008 "configure"
+#line 1044 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1016,5 +1052,5 @@
 }
 EOF
-if { (eval echo configure:1019: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1055: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_long=`cat conftestval`
@@ -1036,5 +1072,5 @@
 
 echo $ac_n "checking size of long long""... $ac_c" 1>&6
-echo "configure:1039: checking size of long long" >&5
+echo "configure:1075: checking size of long long" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_long_long'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1044,5 +1080,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1047 "configure"
+#line 1083 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1055,5 +1091,5 @@
 }
 EOF
-if { (eval echo configure:1058: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1094: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_long_long=`cat conftestval`
@@ -1075,5 +1111,5 @@
 
 echo $ac_n "checking size of float""... $ac_c" 1>&6
-echo "configure:1078: checking size of float" >&5
+echo "configure:1114: checking size of float" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_float'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1083,5 +1119,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1086 "configure"
+#line 1122 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1094,5 +1130,5 @@
 }
 EOF
-if { (eval echo configure:1097: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1133: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_float=`cat conftestval`
@@ -1114,5 +1150,5 @@
 
 echo $ac_n "checking size of double""... $ac_c" 1>&6
-echo "configure:1117: checking size of double" >&5
+echo "configure:1153: checking size of double" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_double'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1122,5 +1158,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1125 "configure"
+#line 1161 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1133,5 +1169,5 @@
 }
 EOF
-if { (eval echo configure:1136: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1172: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_double=`cat conftestval`
@@ -1153,5 +1189,5 @@
 
 echo $ac_n "checking size of long double""... $ac_c" 1>&6
-echo "configure:1156: checking size of long double" >&5
+echo "configure:1192: checking size of long double" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_long_double'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1161,5 +1197,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1164 "configure"
+#line 1200 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1172,5 +1208,5 @@
 }
 EOF
-if { (eval echo configure:1175: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1211: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_long_double=`cat conftestval`
@@ -1194,5 +1230,5 @@
 
 echo $ac_n "checking "for cfitsio lib"""... $ac_c" 1>&6
-echo "configure:1197: checking "for cfitsio lib"" >&5
+echo "configure:1233: checking "for cfitsio lib"" >&5
 MACHDIR=`uname`-$CXX
 if test -f $ARCHBASEREP/$MACHDIR/Libs/libcfitsio.a; then
@@ -1219,5 +1255,5 @@
 
 echo $ac_n "checking "for cfitsio includes"""... $ac_c" 1>&6
-echo "configure:1222: checking "for cfitsio includes"" >&5
+echo "configure:1258: checking "for cfitsio includes"" >&5
 if test -f $CFITSIODIR/fitsio.h; then
   cfitsincdir='-I$(CFITSIODIR)'
@@ -1231,5 +1267,5 @@
 
 echo $ac_n "checking for sin in -lm""... $ac_c" 1>&6
-echo "configure:1234: checking for sin in -lm" >&5
+echo "configure:1270: checking for sin in -lm" >&5
 ac_lib_var=`echo m'_'sin | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
@@ -1239,5 +1275,5 @@
 LIBS="-lm  $LIBS"
 cat > conftest.$ac_ext <<EOF
-#line 1242 "configure"
+#line 1278 "configure"
 #include "confdefs.h"
 /* Override any gcc2 internal prototype to avoid an error.  */
@@ -1250,5 +1286,5 @@
 ; return 0; }
 EOF
-if { (eval echo configure:1253: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext}; then
+if { (eval echo configure:1289: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext}; then
   rm -rf conftest*
   eval "ac_cv_lib_$ac_lib_var=yes"
@@ -1279,5 +1315,5 @@
 
 echo $ac_n "checking how to run the C preprocessor""... $ac_c" 1>&6
-echo "configure:1282: checking how to run the C preprocessor" >&5
+echo "configure:1318: checking how to run the C preprocessor" >&5
 # On Suns, sometimes $CPP names a directory.
 if test -n "$CPP" && test -d "$CPP"; then
@@ -1294,5 +1330,5 @@
   # not just through cpp.
   cat > conftest.$ac_ext <<EOF
-#line 1297 "configure"
+#line 1333 "configure"
 #include "confdefs.h"
 #include <assert.h>
@@ -1300,5 +1336,5 @@
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1303: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1339: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1311,5 +1347,5 @@
   CPP="${CC-cc} -E -traditional-cpp"
   cat > conftest.$ac_ext <<EOF
-#line 1314 "configure"
+#line 1350 "configure"
 #include "confdefs.h"
 #include <assert.h>
@@ -1317,5 +1353,5 @@
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1320: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1356: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1328,5 +1364,5 @@
   CPP="${CC-cc} -nologo -E"
   cat > conftest.$ac_ext <<EOF
-#line 1331 "configure"
+#line 1367 "configure"
 #include "confdefs.h"
 #include <assert.h>
@@ -1334,5 +1370,5 @@
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1337: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1373: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1359,10 +1395,10 @@
 
 echo $ac_n "checking for ANSI C header files""... $ac_c" 1>&6
-echo "configure:1362: checking for ANSI C header files" >&5
+echo "configure:1398: checking for ANSI C header files" >&5
 if eval "test \"`echo '$''{'ac_cv_header_stdc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1367 "configure"
+#line 1403 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
@@ -1372,5 +1408,5 @@
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1375: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1411: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1389,5 +1425,5 @@
   # SunOS 4.x string.h does not declare mem*, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1392 "configure"
+#line 1428 "configure"
 #include "confdefs.h"
 #include <string.h>
@@ -1407,5 +1443,5 @@
   # ISC 2.0.2 stdlib.h does not declare free, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1410 "configure"
+#line 1446 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
@@ -1428,5 +1464,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1431 "configure"
+#line 1467 "configure"
 #include "confdefs.h"
 #include <ctype.h>
@@ -1439,5 +1475,5 @@
 
 EOF
-if { (eval echo configure:1442: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1478: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   :
@@ -1466,15 +1502,15 @@
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:1469: checking for $ac_hdr" >&5
+echo "configure:1505: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1474 "configure"
+#line 1510 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1479: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1515: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1643,4 +1679,5 @@
 s%@CC@%$CC%g
 s%@CXX@%$CXX%g
+s%@AR@%$AR%g
 s%@gcc@%$gcc%g
 s%@cfitslibdir@%$cfitslibdir%g
Index: trunk/ArchTOIPipe/configure.in
===================================================================
--- trunk/ArchTOIPipe/configure.in	(revision 1705)
+++ trunk/ArchTOIPipe/configure.in	(revision 1706)
@@ -18,4 +18,5 @@
 AC_PROG_CC
 AC_PROG_CXX
+AC_PATH_PROG(AR, ar, /usr/bin/ar, /usr/bin:$PATH) 
 
 if test $GCC = "yes"; then