Index: /trunk/ArchTOIPipe/Kernel/Makefile.in
===================================================================
--- /trunk/ArchTOIPipe/Kernel/Makefile.in	(revision 1706)
+++ /trunk/ArchTOIPipe/Kernel/Makefile.in	(revision 1707)
@@ -7,4 +7,5 @@
 CXX=@CXX@
 AR=@AR@
+RANLIB=@RANLIB@
 CXXFLAGS=-O -g
 CFLAGS=-O -g
@@ -82,5 +83,5 @@
 libatkern.a: $(FILES)
 	$(AR) -cr libatkern.a $(FILES)
-	ranlib libatkern.a
+	$(RANLIB) libatkern.a
 	ln -f libatkern.a ../libatkern.a
 
Index: /trunk/ArchTOIPipe/ProcWSophya/Makefile.in
===================================================================
--- /trunk/ArchTOIPipe/ProcWSophya/Makefile.in	(revision 1706)
+++ /trunk/ArchTOIPipe/ProcWSophya/Makefile.in	(revision 1707)
@@ -7,4 +7,5 @@
 CXX=@CXX@
 AR=@AR@
+RANLIB=@RANDLIB@
 CXXFLAGS=-O -g
 CFLAGS=-O -g
@@ -81,5 +82,5 @@
 libatsop.a: $(FILES)
 	$(AR) -cr libatsop.a $(FILES) 
-	ranlib libatsop.a
+	$(RANLIB) libatsop.a
 	ln -f libatsop.a ../libatsop.a
 
Index: /trunk/ArchTOIPipe/Processors/Makefile.in
===================================================================
--- /trunk/ArchTOIPipe/Processors/Makefile.in	(revision 1706)
+++ /trunk/ArchTOIPipe/Processors/Makefile.in	(revision 1707)
@@ -7,4 +7,5 @@
 CXX=@CXX@
 AR=@AR@
+RANLIB=@RANLIB@
 CXXFLAGS=-O -g
 CFLAGS=-O -g
@@ -80,5 +81,5 @@
 libatproc.a: $(FILES)
 	$(AR) -cr libatproc.a $(FILES)  
-	ranlib libatproc.a
+	$(RANLIB) libatproc.a
 	ln -f libatproc.a ../libatproc.a
 
Index: /trunk/ArchTOIPipe/TestPipes/Makefile.in
===================================================================
--- /trunk/ArchTOIPipe/TestPipes/Makefile.in	(revision 1706)
+++ /trunk/ArchTOIPipe/TestPipes/Makefile.in	(revision 1707)
@@ -7,4 +7,5 @@
 CXX=@CXX@
 AR=@AR@
+RANLIB=@RANLIB@
 CXXFLAGS=-O -g
 CFLAGS=-O -g
Index: /trunk/ArchTOIPipe/configure
===================================================================
--- /trunk/ArchTOIPipe/configure	(revision 1706)
+++ /trunk/ArchTOIPipe/configure	(revision 1707)
@@ -946,4 +946,40 @@
 fi
  
+# Extract the first word of "ranlib", so it can be a program name with args.
+set dummy ranlib; ac_word=$2
+echo $ac_n "checking for $ac_word""... $ac_c" 1>&6
+echo "configure:952: checking for $ac_word" >&5
+if eval "test \"`echo '$''{'ac_cv_path_RANLIB'+set}'`\" = set"; then
+  echo $ac_n "(cached) $ac_c" 1>&6
+else
+  case "$RANLIB" in
+  /*)
+  ac_cv_path_RANLIB="$RANLIB" # Let the user override the test with a path.
+  ;;
+  ?:/*)			 
+  ac_cv_path_RANLIB="$RANLIB" # Let the user override the test with a dos path.
+  ;;
+  *)
+  IFS="${IFS= 	}"; ac_save_ifs="$IFS"; IFS=":"
+  ac_dummy="/usr/bin:$PATH"
+  for ac_dir in $ac_dummy; do 
+    test -z "$ac_dir" && ac_dir=.
+    if test -f $ac_dir/$ac_word; then
+      ac_cv_path_RANLIB="$ac_dir/$ac_word"
+      break
+    fi
+  done
+  IFS="$ac_save_ifs"
+  test -z "$ac_cv_path_RANLIB" && ac_cv_path_RANLIB="/usr/bin/ranlib"
+  ;;
+esac
+fi
+RANLIB="$ac_cv_path_RANLIB"
+if test -n "$RANLIB"; then
+  echo "$ac_t""$RANLIB" 1>&6
+else
+  echo "$ac_t""no" 1>&6
+fi
+ 
 
 if test $GCC = "yes"; then
@@ -955,5 +991,5 @@
 
 echo $ac_n "checking size of short""... $ac_c" 1>&6
-echo "configure:958: checking size of short" >&5
+echo "configure:994: checking size of short" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_short'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -963,5 +999,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 966 "configure"
+#line 1002 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -974,5 +1010,5 @@
 }
 EOF
-if { (eval echo configure:977: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1013: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_short=`cat conftestval`
@@ -994,5 +1030,5 @@
 
 echo $ac_n "checking size of int""... $ac_c" 1>&6
-echo "configure:997: checking size of int" >&5
+echo "configure:1033: checking size of int" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_int'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1002,5 +1038,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1005 "configure"
+#line 1041 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1013,5 +1049,5 @@
 }
 EOF
-if { (eval echo configure:1016: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1052: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_int=`cat conftestval`
@@ -1033,5 +1069,5 @@
 
 echo $ac_n "checking size of long""... $ac_c" 1>&6
-echo "configure:1036: checking size of long" >&5
+echo "configure:1072: checking size of long" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_long'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1041,5 +1077,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1044 "configure"
+#line 1080 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1052,5 +1088,5 @@
 }
 EOF
-if { (eval echo configure:1055: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1091: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_long=`cat conftestval`
@@ -1072,5 +1108,5 @@
 
 echo $ac_n "checking size of long long""... $ac_c" 1>&6
-echo "configure:1075: checking size of long long" >&5
+echo "configure:1111: checking size of long long" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_long_long'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1080,5 +1116,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1083 "configure"
+#line 1119 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1091,5 +1127,5 @@
 }
 EOF
-if { (eval echo configure:1094: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1130: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_long_long=`cat conftestval`
@@ -1111,5 +1147,5 @@
 
 echo $ac_n "checking size of float""... $ac_c" 1>&6
-echo "configure:1114: checking size of float" >&5
+echo "configure:1150: checking size of float" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_float'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1119,5 +1155,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1122 "configure"
+#line 1158 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1130,5 +1166,5 @@
 }
 EOF
-if { (eval echo configure:1133: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1169: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_float=`cat conftestval`
@@ -1150,5 +1186,5 @@
 
 echo $ac_n "checking size of double""... $ac_c" 1>&6
-echo "configure:1153: checking size of double" >&5
+echo "configure:1189: checking size of double" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_double'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1158,5 +1194,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1161 "configure"
+#line 1197 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1169,5 +1205,5 @@
 }
 EOF
-if { (eval echo configure:1172: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1208: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_double=`cat conftestval`
@@ -1189,5 +1225,5 @@
 
 echo $ac_n "checking size of long double""... $ac_c" 1>&6
-echo "configure:1192: checking size of long double" >&5
+echo "configure:1228: checking size of long double" >&5
 if eval "test \"`echo '$''{'ac_cv_sizeof_long_double'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
@@ -1197,5 +1233,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1200 "configure"
+#line 1236 "configure"
 #include "confdefs.h"
 #include <stdio.h>
@@ -1208,5 +1244,5 @@
 }
 EOF
-if { (eval echo configure:1211: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1247: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   ac_cv_sizeof_long_double=`cat conftestval`
@@ -1230,5 +1266,5 @@
 
 echo $ac_n "checking "for cfitsio lib"""... $ac_c" 1>&6
-echo "configure:1233: checking "for cfitsio lib"" >&5
+echo "configure:1269: checking "for cfitsio lib"" >&5
 MACHDIR=`uname`-$CXX
 if test -f $ARCHBASEREP/$MACHDIR/Libs/libcfitsio.a; then
@@ -1255,5 +1291,5 @@
 
 echo $ac_n "checking "for cfitsio includes"""... $ac_c" 1>&6
-echo "configure:1258: checking "for cfitsio includes"" >&5
+echo "configure:1294: checking "for cfitsio includes"" >&5
 if test -f $CFITSIODIR/fitsio.h; then
   cfitsincdir='-I$(CFITSIODIR)'
@@ -1267,5 +1303,5 @@
 
 echo $ac_n "checking for sin in -lm""... $ac_c" 1>&6
-echo "configure:1270: checking for sin in -lm" >&5
+echo "configure:1306: checking for sin in -lm" >&5
 ac_lib_var=`echo m'_'sin | sed 'y%./+-%__p_%'`
 if eval "test \"`echo '$''{'ac_cv_lib_$ac_lib_var'+set}'`\" = set"; then
@@ -1275,5 +1311,5 @@
 LIBS="-lm  $LIBS"
 cat > conftest.$ac_ext <<EOF
-#line 1278 "configure"
+#line 1314 "configure"
 #include "confdefs.h"
 /* Override any gcc2 internal prototype to avoid an error.  */
@@ -1286,5 +1322,5 @@
 ; return 0; }
 EOF
-if { (eval echo configure:1289: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext}; then
+if { (eval echo configure:1325: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext}; then
   rm -rf conftest*
   eval "ac_cv_lib_$ac_lib_var=yes"
@@ -1315,5 +1351,5 @@
 
 echo $ac_n "checking how to run the C preprocessor""... $ac_c" 1>&6
-echo "configure:1318: checking how to run the C preprocessor" >&5
+echo "configure:1354: checking how to run the C preprocessor" >&5
 # On Suns, sometimes $CPP names a directory.
 if test -n "$CPP" && test -d "$CPP"; then
@@ -1330,5 +1366,5 @@
   # not just through cpp.
   cat > conftest.$ac_ext <<EOF
-#line 1333 "configure"
+#line 1369 "configure"
 #include "confdefs.h"
 #include <assert.h>
@@ -1336,5 +1372,5 @@
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1339: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1375: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1347,5 +1383,5 @@
   CPP="${CC-cc} -E -traditional-cpp"
   cat > conftest.$ac_ext <<EOF
-#line 1350 "configure"
+#line 1386 "configure"
 #include "confdefs.h"
 #include <assert.h>
@@ -1353,5 +1389,5 @@
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1356: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1392: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1364,5 +1400,5 @@
   CPP="${CC-cc} -nologo -E"
   cat > conftest.$ac_ext <<EOF
-#line 1367 "configure"
+#line 1403 "configure"
 #include "confdefs.h"
 #include <assert.h>
@@ -1370,5 +1406,5 @@
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1373: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1409: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1395,10 +1431,10 @@
 
 echo $ac_n "checking for ANSI C header files""... $ac_c" 1>&6
-echo "configure:1398: checking for ANSI C header files" >&5
+echo "configure:1434: checking for ANSI C header files" >&5
 if eval "test \"`echo '$''{'ac_cv_header_stdc'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1403 "configure"
+#line 1439 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
@@ -1408,5 +1444,5 @@
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1411: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1447: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1425,5 +1461,5 @@
   # SunOS 4.x string.h does not declare mem*, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1428 "configure"
+#line 1464 "configure"
 #include "confdefs.h"
 #include <string.h>
@@ -1443,5 +1479,5 @@
   # ISC 2.0.2 stdlib.h does not declare free, contrary to ANSI.
 cat > conftest.$ac_ext <<EOF
-#line 1446 "configure"
+#line 1482 "configure"
 #include "confdefs.h"
 #include <stdlib.h>
@@ -1464,5 +1500,5 @@
 else
   cat > conftest.$ac_ext <<EOF
-#line 1467 "configure"
+#line 1503 "configure"
 #include "confdefs.h"
 #include <ctype.h>
@@ -1475,5 +1511,5 @@
 
 EOF
-if { (eval echo configure:1478: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
+if { (eval echo configure:1514: \"$ac_link\") 1>&5; (eval $ac_link) 2>&5; } && test -s conftest${ac_exeext} && (./conftest; exit) 2>/dev/null
 then
   :
@@ -1502,15 +1538,15 @@
 ac_safe=`echo "$ac_hdr" | sed 'y%./+-%__p_%'`
 echo $ac_n "checking for $ac_hdr""... $ac_c" 1>&6
-echo "configure:1505: checking for $ac_hdr" >&5
+echo "configure:1541: checking for $ac_hdr" >&5
 if eval "test \"`echo '$''{'ac_cv_header_$ac_safe'+set}'`\" = set"; then
   echo $ac_n "(cached) $ac_c" 1>&6
 else
   cat > conftest.$ac_ext <<EOF
-#line 1510 "configure"
+#line 1546 "configure"
 #include "confdefs.h"
 #include <$ac_hdr>
 EOF
 ac_try="$ac_cpp conftest.$ac_ext >/dev/null 2>conftest.out"
-{ (eval echo configure:1515: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
+{ (eval echo configure:1551: \"$ac_try\") 1>&5; (eval $ac_try) 2>&5; }
 ac_err=`grep -v '^ *+' conftest.out | grep -v "^conftest.${ac_ext}\$"`
 if test -z "$ac_err"; then
@@ -1680,4 +1716,5 @@
 s%@CXX@%$CXX%g
 s%@AR@%$AR%g
+s%@RANLIB@%$RANLIB%g
 s%@gcc@%$gcc%g
 s%@cfitslibdir@%$cfitslibdir%g
Index: /trunk/ArchTOIPipe/configure.in
===================================================================
--- /trunk/ArchTOIPipe/configure.in	(revision 1706)
+++ /trunk/ArchTOIPipe/configure.in	(revision 1707)
@@ -19,4 +19,5 @@
 AC_PROG_CXX
 AC_PATH_PROG(AR, ar, /usr/bin/ar, /usr/bin:$PATH) 
+AC_PATH_PROG(RANLIB, ranlib, /usr/bin/ranlib, /usr/bin:$PATH) 
 
 if test $GCC = "yes"; then