Index: /trunk/ArchTOIPipe/TestPipes/tstmap2toi.cc
===================================================================
--- /trunk/ArchTOIPipe/TestPipes/tstmap2toi.cc	(revision 1722)
+++ /trunk/ArchTOIPipe/TestPipes/tstmap2toi.cc	(revision 1723)
@@ -1,2 +1,4 @@
+//#define TOISEQBUFFERED
+
 #include <unistd.h>
 #include <stdexcept>
@@ -7,5 +9,9 @@
 #include "fitstoiwtr.h"
 #include "toimanager.h"
+#ifdef TOISEQBUFFERED
 #include "toiseqbuff.h"
+#else
+#include "toisegment.h"
+#endif
 
 #include "sambainit.h"
@@ -156,23 +162,45 @@
 
  // Definition des tuyaux
+#ifdef TOISEQBUFFERED
+ cout<<">>>> Using TOISeqBuffered"<<endl;
  TOISeqBuffered * toicoord1in = new TOISeqBuffered("toi_coord1_in",width);
+#else
+ cout<<">>>> Using TOISegmented"<<endl;
+ TOISegmented * toicoord1in = new TOISegmented("toi_coord1_in",width);
+#endif
  // toicoord1in->setDebugLevel(1);
  rfits.addOutput(label_coord1,toicoord1in);
  m2toi.addInput("Coord1In",toicoord1in);
 
+#ifdef TOISEQBUFFERED
  TOISeqBuffered * toicoord1out = new TOISeqBuffered("toi_coord1_out",width);
+#else
+ TOISegmented * toicoord1out = new TOISegmented("toi_coord1_out",width);
+#endif
  m2toi.addOutput("Coord1Out",toicoord1out);
  wfits.addInput(label_coord1,toicoord1out);
 
+#ifdef TOISEQBUFFERED
  TOISeqBuffered * toicoord2in = new TOISeqBuffered("toi_coord2_in",width);
+#else
+ TOISegmented * toicoord2in = new TOISegmented("toi_coord2_in",width);
+#endif
  // toicoord2in->setDebugLevel(1);
  rfits.addOutput(label_coord2,toicoord2in);
  m2toi.addInput("Coord2In",toicoord2in);
 
+#ifdef TOISEQBUFFERED
  TOISeqBuffered * toicoord2out = new TOISeqBuffered("toi_coord2_out",width);
+#else
+ TOISegmented * toicoord2out = new TOISegmented("toi_coord2_out",width);
+#endif
  m2toi.addOutput("Coord2Out",toicoord2out);
  wfits.addInput(label_coord2,toicoord2out);
 
+#ifdef TOISEQBUFFERED
  TOISeqBuffered * toibolout = new TOISeqBuffered("toi_bolo_out",width);
+#else
+ TOISegmented * toibolout = new TOISegmented("toi_bolo_out",width);
+#endif
  // toibolout->setDebugLevel(1);
  m2toi.addOutput("BoloOut",toibolout);
@@ -198,7 +226,7 @@
 
  //  Affichage de l'avancement des TOIProcessors 
- ProcSampleCounter<FITSTOIReader>  stats(rfits);
- stats.InfoMessage() = "tstmap2toi/Info";
- stats.PrintStats();
+ //ProcSampleCounter<FITSTOIReader>  stats(rfits);
+ //stats.InfoMessage() = "tstmap2toi/Info";
+ //stats.PrintStats();
 
  mgr->joinAll();
Index: /trunk/ArchTOIPipe/TestPipes/tsttoi2map.cc
===================================================================
--- /trunk/ArchTOIPipe/TestPipes/tsttoi2map.cc	(revision 1722)
+++ /trunk/ArchTOIPipe/TestPipes/tsttoi2map.cc	(revision 1723)
@@ -1,2 +1,4 @@
+//#define TOISEQBUFFERED
+
 #include <unistd.h>
 #include <stdexcept>
@@ -8,9 +10,13 @@
 #include "fitstoiwtr.h"
 #include "toimanager.h"
+#ifdef TOISEQBUFFERED
 #include "toiseqbuff.h"
+#else
+#include "toisegment.h"
+#endif
 
 #include "sambainit.h"
 #include "toi2map.h"
-#include "fitsspherehealpix.h" 
+#include "fitsspherehealpix.h"
 #include "timing.h"
 
@@ -191,15 +197,29 @@
 
  // Definition des tuyaux
+#ifdef TOISEQBUFFERED
+ cout<<">>>> Using TOISeqBuffered"<<endl;
  TOISeqBuffered * toicoord1in = new TOISeqBuffered("toi_coord1_in",width);
+#else
+ cout<<">>>> Using TOISegmented"<<endl;
+ TOISegmented * toicoord1in = new TOISegmented("toi_coord1_in",width);
+#endif
  // toicoord1in->setDebugLevel(1);
  rfitsp.addOutput(label_coord1,toicoord1in);
  toi2m.addInput("Coord1In",toicoord1in);
 
+#ifdef TOISEQBUFFERED
  TOISeqBuffered * toicoord2in = new TOISeqBuffered("toi_coord2_in",width);
+#else
+ TOISegmented * toicoord2in = new TOISegmented("toi_coord2_in",width);
+#endif
  // toicoord2in->setDebugLevel(1);
  rfitsp.addOutput(label_coord2,toicoord2in);
  toi2m.addInput("Coord2In",toicoord2in);
  
+#ifdef TOISEQBUFFERED
  TOISeqBuffered * toibolin = new TOISeqBuffered("toi_bolo_in",width);
+#else
+ TOISegmented * toibolin = new TOISegmented("toi_bolo_in",width);
+#endif
  // toibolin->setDebugLevel(1);
  rfitsb.addOutput(label_bolomuv,toibolin);
@@ -216,15 +236,15 @@
  toi2m.start();
 
- if(lp>1)
-   for(int jjjj=0;jjjj<5;jjjj++) {
-     cout<<*toicoord1in; 
-     cout<<*toibolin; 
-     sleep(2);
-   }
+ // if(lp>1)
+ //   for(int jjjj=0;jjjj<5;jjjj++) {
+ //     cout<<*toicoord1in; 
+ //     cout<<*toibolin; 
+ //     sleep(2);
+ //   }
 
  //  Affichage de l'avancement des TOIProcessors 
- ProcSampleCounter<FITSTOIReader>  stats(rfitsb);
- stats.InfoMessage() = "tsttoi2map/Info";
- stats.PrintStats();
+ // ProcSampleCounter<FITSTOIReader>  stats(rfitsb);
+ // stats.InfoMessage() = "tsttoi2map/Info";
+ // stats.PrintStats();
 
  // Fin des traitements des TOIProcessors  